Index: code/trunk/src/orxonox/InputManager.h
===================================================================
--- code/trunk/src/orxonox/InputManager.h	(revision 790)
+++ code/trunk/src/orxonox/InputManager.h	(revision 790)
@@ -0,0 +1,93 @@
+#ifndef _InputManager_H__
+#define _InputManager_H__
+
+#ifdef WIN32
+#include <OIS/OISMouse.h>
+#include <OIS/OISKeyboard.h>
+#include <OIS/OISJoyStick.h>
+#include <OIS/OISInputManager.h>
+#else
+#include <OISMouse.h>
+#include <OISKeyboard.h>
+#include <OISJoyStick.h>
+#include <OISInputManager.h>
+#endif
+
+#include <OgreRenderWindow.h>
+
+#include "OrxonoxPrereqs.h"
+
+class _OrxonoxExport InputManager : public OIS::KeyListener, public OIS::MouseListener, public OIS::JoyStickListener {
+  public:
+    virtual ~InputManager( void );
+
+    void initialise( Ogre::RenderWindow *renderWindow );
+    void capture( void );
+
+    void addKeyListener( OIS::KeyListener *keyListener, const std::string& instanceName );
+    void addMouseListener( OIS::MouseListener *mouseListener, const std::string& instanceName );
+    void addJoystickListener( OIS::JoyStickListener *joystickListener, const std::string& instanceName );
+
+    void removeKeyListener( const std::string& instanceName );
+    void removeMouseListener( const std::string& instanceName );
+    void removeJoystickListener( const std::string& instanceName );
+
+    void removeKeyListener( OIS::KeyListener *keyListener );
+    void removeMouseListener( OIS::MouseListener *mouseListener );
+    void removeJoystickListener( OIS::JoyStickListener *joystickListener );
+
+    void removeAllListeners( void );
+    void removeAllKeyListeners( void );
+    void removeAllMouseListeners( void );
+    void removeAllJoystickListeners( void );
+
+    void setWindowExtents( int width, int height );
+
+    OIS::Mouse*    getMouse( void );
+    OIS::Keyboard* getKeyboard( void );
+    OIS::JoyStick* getJoystick( unsigned int index );
+
+    int getNumOfJoysticks( void );
+
+    static InputManager* getSingletonPtr( void );
+  private:
+    InputManager( void );
+    InputManager( const InputManager& ) { }
+    InputManager & operator = ( const InputManager& );
+
+    bool keyPressed( const OIS::KeyEvent &e );
+    bool keyReleased( const OIS::KeyEvent &e );
+
+    bool mouseMoved( const OIS::MouseEvent &e );
+    bool mousePressed( const OIS::MouseEvent &e, OIS::MouseButtonID id );
+    bool mouseReleased( const OIS::MouseEvent &e, OIS::MouseButtonID id );
+
+    bool povMoved( const OIS::JoyStickEvent &e, int pov );
+    bool axisMoved( const OIS::JoyStickEvent &e, int axis );
+    bool sliderMoved( const OIS::JoyStickEvent &e, int sliderID );
+    bool buttonPressed( const OIS::JoyStickEvent &e, int button );
+    bool buttonReleased( const OIS::JoyStickEvent &e, int button );
+
+    OIS::Mouse        *mMouse;
+    OIS::Keyboard     *mKeyboard;
+    OIS::InputManager *mInputSystem;
+
+    std::vector<OIS::JoyStick*> mJoysticks;
+    std::vector<OIS::JoyStick*>::iterator itJoystick;
+    std::vector<OIS::JoyStick*>::iterator itJoystickEnd;
+
+    std::map<std::string, OIS::KeyListener*> mKeyListeners;
+    std::map<std::string, OIS::MouseListener*> mMouseListeners;
+    std::map<std::string, OIS::JoyStickListener*> mJoystickListeners;
+
+    std::map<std::string, OIS::KeyListener*>::iterator itKeyListener;
+    std::map<std::string, OIS::MouseListener*>::iterator itMouseListener;
+    std::map<std::string, OIS::JoyStickListener*>::iterator itJoystickListener;
+
+    std::map<std::string, OIS::KeyListener*>::iterator itKeyListenerEnd;
+    std::map<std::string, OIS::MouseListener*>::iterator itMouseListenerEnd;
+    std::map<std::string, OIS::JoyStickListener*>::iterator itJoystickListenerEnd;
+
+    static InputManager *mInputManager;
+};
+#endif /* _InputManager_H__ */
Index: code/trunk/src/orxonox/Main.cc
===================================================================
--- code/trunk/src/orxonox/Main.cc	(revision 790)
+++ code/trunk/src/orxonox/Main.cc	(revision 790)
@@ -0,0 +1,209 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Benjamin Knecht <beni_at_orxonox.net>, (C) 2007
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+ /**
+ @file  Main.cc
+ @brief main file handling most of the machine specific code
+  */
+
+#include "OrxonoxStableHeaders.h"
+
+#include <OgrePlatform.h>
+#include <OgreException.h>
+
+
+#include "core/SignalHandler.h"
+#include "Orxonox.h"
+
+using namespace orxonox;
+#if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
+#include <CoreFoundation/CoreFoundation.h>
+
+// This function will locate the path to our application on OS X,
+// unlike windows you can not rely on the curent working directory
+// for locating your configuration files and resources.
+             std::string macBundlePath()
+{
+  char path[1024];
+  CFBundleRef mainBundle = CFBundleGetMainBundle();
+  assert(mainBundle);
+
+  CFURLRef mainBundleURL = CFBundleCopyBundleURL(mainBundle);
+  assert(mainBundleURL);
+
+  CFStringRef cfStringRef = CFURLCopyFileSystemPath( mainBundleURL, kCFURLPOSIXPathStyle);
+  assert(cfStringRef);
+
+  CFStringGetCString(cfStringRef, path, 1024, kCFStringEncodingASCII);
+
+  CFRelease(mainBundleURL);
+  CFRelease(cfStringRef);
+
+  return std::string(path);
+}
+#endif
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32 && !defined( __MINGW32__ )
+#ifndef WIN32_LEAN_AND_MEAN
+#define WIN32_LEAN_AND_MEAN
+#endif
+#include "windows.h"
+  INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT)
+  {
+    // something like this would be less hacky
+    // maybe one can work with trailing '\0'
+    // or maybe use string based functions
+    // I was unable to test it without working windows version
+    char* cmd = strCmdLine;
+    int argc = 2;
+    int i;
+    int j;
+    for(i = 0; cmd[i] != NULL; i++)
+    {
+      if(cmd[i] == ' ') argc++;
+    }
+    char **argv = new char*[argc];
+    for (j = 0; j < argc; j++)
+    {
+      argv[j] = new char[i];
+    }
+    j = 1;
+    int k = 0;
+    for(int i = 0; cmd[i] != NULL; i++)
+    {
+      if(cmd[i] != ' ') {
+        argv[j][k] = cmd[i];
+        k++;
+      }
+      else {
+        argv[j][k] = '\0';
+        k = 0;
+        j++;
+      }
+    }
+    argv[j][k] = '\0';
+    argv[0] = "BeniXonox.exe";
+    //char *argv[2];
+    //argv[0] = "asdfProgram";
+    //argv[1] =  strCmdLine;
+    //int argc = 2;
+#else
+  int main(int argc, char **argv)
+  {
+#endif
+    try {
+      srand(time(0));  //initaialize RNG; TODO check if it works on win
+      SignalHandler::getInstance()->doCatch(argv[0], "orxonox.log");
+      Orxonox* orx = Orxonox::getSingleton();
+#if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
+      orx->init(argc, argv, macBundlePath());
+      orx->start();
+#else
+/*
+for (int i = 0; i < 500; i++)
+{
+int x = rand() % 40000 - 20000;
+int y = rand() % 40000 - 20000;
+int z = rand() % 40000 - 20000;
+
+int scale = rand() % 100 + 20;
+
+int version = rand() % 6 + 1;
+
+float rotx = float(rand()) / RAND_MAX;
+float roty = float(rand()) / RAND_MAX;
+float rotz = float(rand()) / RAND_MAX;
+
+int axis = rand() % 3 + 1;
+
+if (axis == 1)
+  rotx = 0;
+if (axis == 2)
+  roty = 0;
+if (axis == 3)
+  rotz = 0;
+
+int rotation = rand() % 40 + 10;
+
+//    <Model position="1000,1500,0" scale="50" mesh="ast1.mesh" rotationAxis="0,1.25,0" rotationRate="70" />
+std::cout << "    <Model position=\"" << x << "," << y << "," << z << "\" scale=\"" << scale << "\" mesh=\"ast" << version << ".mesh\" rotationAxis=\"" << rotx << "," << roty << "," << rotz << "\" rotationRate=\"" << rotation << "\" />" << std::endl;
+
+
+}
+*/
+      orx->init(argc, argv, "");
+      orx->start();
+#endif
+    }
+    catch (Ogre::Exception& e) {
+#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32 && !defined( __MINGW32__ )
+      MessageBoxA(NULL, e.getFullDescription().c_str(),
+            "An exception has occured!", MB_OK | MB_ICONERROR | MB_TASKMODAL);
+#else
+      std::cerr << "Exception:\n";
+      std::cerr << e.getFullDescription().c_str() << "\n";
+#endif
+      return 1;
+    }
+    return 0;
+  }
+
+#ifdef __cplusplus
+}
+#endif
+
+
+/*int main(int argc, char **argv)
+{
+  try
+  {
+    SignalHandler::getInstance()->doCatch(argv[0], "orxonox.log");
+    Orxonox* orx = Orxonox::getSingleton();
+#if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
+    orx->init(argc, argv, macBundlePath());
+    orx->start();
+#else
+    orx->init(argc, argv, "");
+    orx->start();
+#endif
+
+  }
+  catch(Ogre::Exception& e)
+  {
+    fprintf(stderr, "An exception has occurred: %s\n",
+            e.getFullDescription().c_str());
+    return 1;
+  }
+
+  return 0;
+}
+
+*/
Index: code/trunk/src/orxonox/Orxonox.cc
===================================================================
--- code/trunk/src/orxonox/Orxonox.cc	(revision 790)
+++ code/trunk/src/orxonox/Orxonox.cc	(revision 790)
@@ -0,0 +1,481 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Benjamin Knecht <beni_at_orxonox.net>, (C) 2007
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file  Orxonox.cc
+ @brief Orxonox Main Class
+ */
+
+// Precompiled Headers
+#include "OrxonoxStableHeaders.h"
+
+//****** OGRE ******
+#include <OgreException.h>
+#include <OgreRoot.h>
+#include <OgreFrameListener.h>
+#include <OgreRenderWindow.h>
+#include <OgreTextureManager.h>
+#include <OgreResourceGroupManager.h>
+#include <OgreConfigFile.h>
+#include <OgreOverlay.h>
+#include <OgreOverlayManager.h>
+
+//****** OIS *******
+#include <OIS/OIS.h>
+
+//****** STD *******
+#include <iostream>
+#include <exception>
+
+//***** ORXONOX ****
+//misc
+#include "util/Sleep.h"
+
+// loader and audio
+#include "loader/LevelLoader.h"
+#include "audio/AudioManager.h"
+
+// network
+#include "network/Server.h"
+#include "network/Client.h"
+#include "network/NetworkFrameListener.h"
+
+// objects
+#include "objects/Tickable.h"
+#include "tools/Timer.h"
+#include "objects/NPC.h"
+#include "core/ArgReader.h"
+#include "core/Factory.h"
+#include "core/Debug.h"
+#include "hud/HUD.h"
+#include "objects/weapon/BulletManager.h"
+#include "GraphicsEngine.h"
+
+#include "Orxonox.h"
+
+namespace orxonox
+{
+   // put this in a seperate Class or solve the problem in another fashion
+  class OrxListener : public Ogre::FrameListener
+  {
+    public:
+      OrxListener(OIS::Keyboard *keyboard, audio::AudioManager*  auMan, gameMode mode)
+      {
+        mKeyboard = keyboard;
+        mode_=mode;
+        auMan_ = auMan;
+      }
+
+      bool frameStarted(const Ogre::FrameEvent& evt)
+      {
+        auMan_->update();
+        updateAI();
+
+        if(mode_ == PRESENTATION)
+          server_g->tick(evt.timeSinceLastFrame);
+        else if(mode_ == CLIENT)
+          client_g->tick(evt.timeSinceLastFrame);
+
+        usleep(10);
+
+        mKeyboard->capture();
+        return !mKeyboard->isKeyDown(OIS::KC_ESCAPE);
+      }
+
+      void updateAI()
+      {
+        for(Iterator<NPC> it = ObjectList<NPC>::start(); it; ++it)
+        {
+          it->update();
+        }
+      }
+
+    private:
+      gameMode mode_;
+      OIS::Keyboard *mKeyboard;
+      audio::AudioManager*  auMan_;
+  };
+
+  // init static singleton reference of Orxonox
+  Orxonox* Orxonox::singletonRef_ = NULL;
+
+  /**
+   * create a new instance of Orxonox
+   */
+  Orxonox::Orxonox()
+  {
+    this->ogre_ = new GraphicsEngine();
+    this->dataPath_ = "";
+    this->loader_ = 0;
+    this->auMan_ = 0;
+    this->singletonRef_ = 0;
+    this->keyboard_ = 0;
+    this->mouse_ = 0;
+    this->inputManager_ = 0;
+    this->frameListener_ = 0;
+    this->root_ = 0;
+  }
+
+  /**
+   * destruct Orxonox
+   */
+  Orxonox::~Orxonox()
+  {
+    // nothing to delete as for now
+  }
+
+  /**
+   * initialization of Orxonox object
+   * @param argc argument counter
+   * @param argv list of arguments
+   * @param path path to config (in home dir or something)
+   */
+  void Orxonox::init(int argc, char **argv, std::string path)
+  {
+    //TODO: find config file (assuming executable directory)
+    //TODO: read config file
+    //TODO: give config file to Ogre
+    std::string mode;
+//     if(argc>=2)
+//       mode = std::string(argv[1]);
+//     else
+//       mode = "";
+    ArgReader ar = ArgReader(argc, argv);
+    ar.checkArgument("mode", mode, false);
+    ar.checkArgument("data", this->dataPath_, false);
+    ar.checkArgument("ip", serverIp_, false);
+    //mode = "presentation";
+    if(ar.errorHandling()) die();
+    if(mode == std::string("server"))
+    {
+      serverInit(path);
+      mode_ = SERVER;
+    }
+    else if(mode == std::string("client"))
+    {
+      clientInit(path);
+      mode_ = CLIENT;
+    }
+    else if(mode == std::string("presentation"))
+    {
+      serverInit(path);
+      mode_ = PRESENTATION;
+    }
+    else{
+      standaloneInit(path);
+      mode_ = STANDALONE;
+    }
+  }
+
+  /**
+   * start modules
+   */
+  void Orxonox::start()
+  {
+    //TODO: start modules
+    ogre_->startRender();
+    //TODO: run engine
+    Factory::createClassHierarchy();
+    createScene();
+    setupScene();
+    setupInputSystem();
+    if(mode_!=CLIENT){ // remove this in future ---- presentation hack
+    }
+    else
+      std::cout << "client here" << std::endl;
+    createFrameListener();
+    switch(mode_){
+    case PRESENTATION:
+      //ogre_->getRoot()->addFrameListener(new network::ServerFrameListener());
+      //std::cout << "could not add framelistener" << std::endl;
+      server_g->open();
+      break;
+    case CLIENT:
+      client_g->establishConnection();
+      break;
+    case SERVER:
+    case STANDALONE:
+    default:
+      break;
+    }
+    startRenderLoop();
+  }
+
+  /**
+   * @return singleton object
+   */
+  Orxonox* Orxonox::getSingleton()
+  {
+    if (!singletonRef_)
+      singletonRef_ = new Orxonox();
+    return singletonRef_;
+  }
+
+  /**
+   * error kills orxonox
+   */
+  void Orxonox::die(/* some error code */)
+  {
+    //TODO: destroy and destruct everything and print nice error msg
+    delete this;
+  }
+
+  void Orxonox::standaloneInit(std::string path)
+  {
+    ogre_->setConfigPath(path);
+    ogre_->setup();
+    root_ = ogre_->getRoot();
+    if(!ogre_->load()) die(/* unable to load */);
+
+    //defineResources();
+    //setupRenderSystem();
+    //createRenderWindow();
+    //initializeResourceGroups();
+    /*createScene();
+    setupScene();
+    setupInputSystem();
+    createFrameListener();
+    Factory::createClassHierarchy();
+    startRenderLoop();*/
+  }
+
+  void Orxonox::playableServer(std::string path)
+  {
+    ogre_->setConfigPath(path);
+    ogre_->setup();
+    root_ = ogre_->getRoot();
+    defineResources();
+    setupRenderSystem();
+    createRenderWindow();
+    initializeResourceGroups();
+    setupInputSystem();
+    Factory::createClassHierarchy();
+    createScene();
+    setupScene();
+    createFrameListener();
+    try{
+      server_g = new network::Server(); //!< add port and bindadress
+      server_g->open(); //!< open server and create listener thread
+      if(ogre_ && ogre_->getRoot())
+        ogre_->getRoot()->addFrameListener(new network::ServerFrameListener()); // adds a framelistener for the server
+      COUT(3) << "Info: network framelistener added" << std::endl;
+    }
+    catch(...)
+    {
+      COUT(1) << "Error: There was a problem initialising the server :(" << std::endl;
+    }
+    startRenderLoop();
+  }
+
+  void Orxonox::standalone(){
+
+
+
+  }
+
+  void Orxonox::serverInit(std::string path)
+  {
+    COUT(2) << "initialising server" << std::endl;
+    ogre_->setConfigPath(path);
+    ogre_->setup();
+    server_g = new network::Server(); // FIXME add some settings if wanted
+    if(!ogre_->load()) die(/* unable to load */);
+    // FIXME add network framelistener
+  }
+
+  void Orxonox::clientInit(std::string path)
+  {
+    COUT(2) << "initialising client" << std::endl;
+    ogre_->setConfigPath(path);
+    ogre_->setup();
+    if(serverIp_.compare("")==0)
+      client_g = new network::Client();
+    else
+      client_g = new network::Client(serverIp_, 55556);
+    if(!ogre_->load()) die(/* unable to load */);
+    ogre_->getRoot()->addFrameListener(new network::ClientFrameListener());
+  }
+
+  void Orxonox::defineResources()
+  {
+    std::string secName, typeName, archName;
+    Ogre::ConfigFile cf;
+#if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
+    cf.load(macBundlePath() + "/Contents/Resources/resources.cfg");
+#else
+    cf.load(dataPath_ + "resources.cfg");
+#endif
+
+    Ogre::ConfigFile::SectionIterator seci = cf.getSectionIterator();
+    while (seci.hasMoreElements())
+    {
+      secName = seci.peekNextKey();
+      Ogre::ConfigFile::SettingsMultiMap *settings = seci.getNext();
+      Ogre::ConfigFile::SettingsMultiMap::iterator i;
+      for (i = settings->begin(); i != settings->end(); ++i)
+      {
+        typeName = i->first;
+        archName = i->second;
+#if OGRE_PLATFORM == OGRE_PLATFORM_APPLE
+        Ogre::ResourceGroupManager::getSingleton().addResourceLocation( std::string(macBundlePath() + "/" + archName), typeName, secName);
+#else
+        Ogre::ResourceGroupManager::getSingleton().addResourceLocation( archName, typeName, secName);
+#endif
+      }
+    }
+  }
+
+  void Orxonox::setupRenderSystem()
+  {
+    if (!root_->restoreConfig() && !root_->showConfigDialog())
+      throw Ogre::Exception(52, "User canceled the config dialog!", "OrxApplication::setupRenderSystem()");
+  }
+
+  void Orxonox::createRenderWindow()
+  {
+    root_->initialise(true, "OrxonoxV2");
+  }
+
+  void Orxonox::initializeResourceGroups()
+  {
+    Ogre::TextureManager::getSingleton().setDefaultNumMipmaps(5);
+    Ogre::ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
+  }
+
+  /**
+   *
+   * @param
+   */
+  void Orxonox::createScene(void)
+  {
+	// Init audio
+    auMan_ = new audio::AudioManager();
+
+    bulletMgr_ = new BulletManager();
+
+    // load this file from config
+    loader_ = new loader::LevelLoader("sample.oxw");
+    loader_->loadLevel();
+
+    Ogre::Overlay* hudOverlay = Ogre::OverlayManager::getSingleton().getByName("Orxonox/HUD1.2");
+    HUD* orxonoxHud;
+    orxonoxHud = new HUD();
+    orxonoxHud->setEnergyValue(20);
+    orxonoxHud->setEnergyDistr(20,20,60);
+    hudOverlay->show();
+
+	/*
+    auMan_->ambientAdd("a1");
+    auMan_->ambientAdd("a2");
+    auMan_->ambientAdd("a3");
+                                //auMan->ambientAdd("ambient1");
+    auMan_->ambientStart();*/
+  }
+
+
+  /**
+   *
+   */
+  void Orxonox::setupScene()
+  {
+//    SceneManager *mgr = ogre_->getSceneManager();
+
+
+//    SceneNode* node = (SceneNode*)mgr->getRootSceneNode()->getChild("OgreHeadNode");
+//     SceneNode *node = mgr->getRootSceneNode()->createChildSceneNode("OgreHeadNode", Vector3(0,0,0));
+
+
+/*
+    particle::ParticleInterface *e = new particle::ParticleInterface(mgr,"engine","Orxonox/strahl");
+    e->particleSystem_->setParameter("local_space","true");
+    e->setPositionOfEmitter(0, Vector3(0,-10,0));
+    e->setDirection(Vector3(0,0,-1));
+    e->addToSceneNode(node);
+*/
+  }
+
+
+  void Orxonox::setupInputSystem()
+  {
+    size_t windowHnd = 0;
+    std::ostringstream windowHndStr;
+    OIS::ParamList pl;
+
+    // fixes auto repeat problem
+    #if defined OIS_LINUX_PLATFORM
+      pl.insert(std::make_pair(std::string("XAutoRepeatOn"), std::string("true")));
+    #endif
+
+      Ogre::RenderWindow *win = ogre_->getRoot()->getAutoCreatedWindow();
+    win->getCustomAttribute("WINDOW", &windowHnd);
+    windowHndStr << windowHnd;
+    pl.insert(std::make_pair(std::string("WINDOW"), windowHndStr.str()));
+    inputManager_ = OIS::InputManager::createInputSystem(pl);
+
+    try
+    {
+      keyboard_ = static_cast<OIS::Keyboard*>(inputManager_->createInputObject(OIS::OISKeyboard, false));
+      mouse_ = static_cast<OIS::Mouse*>(inputManager_->createInputObject(OIS::OISMouse, true));
+    }
+    catch (const OIS::Exception &e)
+    {
+      throw new Ogre::Exception(42, e.eText, "OrxApplication::setupInputSystem");
+    }
+  }
+
+  // FIXME we actually want to do this differently...
+  void Orxonox::createFrameListener()
+  {
+    TickFrameListener* TickFL = new TickFrameListener();
+    ogre_->getRoot()->addFrameListener(TickFL);
+
+    TimerFrameListener* TimerFL = new TimerFrameListener();
+    ogre_->getRoot()->addFrameListener(TimerFL);
+
+    //if(mode_!=CLIENT) // FIXME just a hack ------- remove this in future
+      frameListener_ = new OrxListener(keyboard_, auMan_, mode_);
+    ogre_->getRoot()->addFrameListener(frameListener_);
+  }
+
+  void Orxonox::startRenderLoop()
+  {
+    // FIXME
+    // this is a hack!!!
+    // the call to reset the mouse clipping size should probably be somewhere
+    // else, however this works for the moment.
+    unsigned int width, height, depth;
+    int left, top;
+    ogre_->getRoot()->getAutoCreatedWindow()->getMetrics(width, height, depth, left, top);
+
+    if(mode_!=CLIENT){
+      const OIS::MouseState &ms = mouse_->getMouseState();
+      ms.width = width;
+      ms.height = height;
+    }
+    ogre_->getRoot()->startRendering();
+  }
+}
Index: code/trunk/src/orxonox/Orxonox.h
===================================================================
--- code/trunk/src/orxonox/Orxonox.h	(revision 790)
+++ code/trunk/src/orxonox/Orxonox.h	(revision 790)
@@ -0,0 +1,86 @@
+/**
+ @file  Orxonox.h
+ @brief Main Orxonox Class File
+ @author Benjamin Knecht <beni_at_orxonox.net>
+ */
+
+#ifndef _Orxonox_H__
+#define _Orxonox_H__
+
+#include <string>
+
+#include <OgrePrerequisites.h>
+#include <OIS/OISPrereqs.h>
+
+#include "OrxonoxPrereqs.h"
+#include "loader/LoaderPrereqs.h"
+#include "audio/AudioPrereqs.h"
+
+#include "GraphicsEngine.h"
+
+
+// TODO: Orxonox should maybe derive from BaseObject
+//! Orxonox singleton class
+namespace orxonox {
+
+  enum gameMode{
+    STANDALONE,
+    SERVER,
+    CLIENT,
+    PRESENTATION
+  };
+
+  class _OrxonoxExport Orxonox
+  {
+    public:
+      void init(int argc, char **argv, std::string path);
+      void start();
+      // not sure if this should be private
+      void die(/* some error code */);
+      static Orxonox* getSingleton();
+      inline Ogre::SceneManager* getSceneManager()         { return ogre_->getSceneManager(); };
+      inline GraphicsEngine* getOgrePointer()              { return ogre_; };
+      inline audio::AudioManager* getAudioManagerPointer() { return auMan_; };
+      inline OIS::Keyboard* getKeyboard()                  { return this->keyboard_; }
+      inline OIS::Mouse* getMouse()                        { return this->mouse_; }
+      inline BulletManager* getBulletMgr()                 { return this->bulletMgr_; }
+
+    private:
+      Orxonox();
+      virtual ~Orxonox();
+      // init functions
+      void serverInit(std::string path);
+      void clientInit(std::string path);
+      void standaloneInit(std::string path);
+      // run functions
+      void playableServer(std::string path);
+      void standalone();
+      void defineResources();
+      void setupRenderSystem();
+      void createRenderWindow();
+      void initializeResourceGroups();
+      void createScene(void);
+      void setupScene();
+      void setupInputSystem();
+      void createFrameListener();
+      void startRenderLoop();
+
+    private:
+      GraphicsEngine*       ogre_;          //!< our dearest graphics engine <3
+      std::string           dataPath_;      //!< path to data
+      loader::LevelLoader*  loader_;        //!< level loader builds the scene
+      audio::AudioManager*  auMan_;         //!< audio manager
+      BulletManager*        bulletMgr_;     //!< Keeps track of the thrown bullets
+      static Orxonox*       singletonRef_;
+      OIS::Keyboard*        keyboard_;
+      OIS::Mouse*           mouse_;
+      OIS::InputManager*    inputManager_;
+      OrxListener*          frameListener_;
+      Ogre::Root*           root_;
+
+      // this is used to identify the mode (server/client/...) we're in
+      gameMode              mode_;
+      std::string           serverIp_;
+  };
+}
+#endif /* _Orxonox_H__ */
